/*
 GB Nintendo Logo Emulator - Read 3 example
 Author: Alex from Inside Gadgets (http://www.insidegadgets.com)
 
 */

byte addrarray[1500];
int addrcounter = 0;

void setup() {
  Serial.begin(57600);
  DDRD |= B00000000; // D2 - D7 input
  DDRB |= B00000000; // D8 - D9 input
}

void loop() {
  
  // Wait for serial input
  while (Serial.available() <= 0) {
    delay(200);
  }
  Serial.flush();
  addrcounter = 0;
  
  byte addressLines = PIND >> 2;
  while (addressLines == 0) {
    addressLines = PIND >> 2; // Only read address lines A0-A6 as others aren't needed
    if (addressLines > 0) { // Hit the noise
      delay(50);
    }
  }
  
  while (addressLines & 1 == 1) {
     addressLines = PIND >> 2;
  }

  while (addrcounter < 1500) {
    while (addressLines >= 250) { // Ignore this data
       addressLines = (PINB << 6) | (PIND >> 2);
    }
    addressLines = (PINB << 6) | (PIND >> 2);
    addrarray[addrcounter] = addressLines;
    addrcounter++;
  }
    
  // Print out
  for (int x = 0; x < addrcounter; x++) {
    for (int z = 7; z >= 0; z--) {
        if (bitRead(addrarray[x], z) == HIGH) {
          Serial.print("1");
        }
        else {
          Serial.print("0");
        }
      }
      Serial.print("\t");
    Serial.println(addrarray[x], DEC);
  } 
}
